# encoding: utf-8

# Exemplos de funções e testes.
#
# Página: http://malbarbo.pro.br/ensino/2013/7256/
# Autor : Marco A L Barbosa <marco@malbarbo.pro.br>

from aed import Struct, executa_testes

# Exemplo 1
# Defina uma função que produza o dobro de um dado valor.

def dobro(x):
    '''
    Número -> Número    
    Produz o dobro de x.
    Exemplos
    >>> dobro(3)
    6
    >>> dobro(4.3)
    8.6
    '''
    return 2 * x

# Exemplo 2
# Defina uma função que encontre o valor máximo entre 3 valores dados.

def maximo(a, b, c):
    '''
    Número, Número, Número -> Número
    Devolve o valor máximo entre a, b e c
    Exemplos
    >>> maximo(7, 1, 2)
    7
    >>> maximo(2, 8, -2)
    8
    >>> maximo(2, 3, 4)
    4
    >>> maximo(3, 1, 3)
    3
    '''
    if a > b:
        if a > c:
            return a
        else:
            return c
    else:
        if b > c:
            return b
        else:
            return c

# Exemplo 3
# Dados dois número inteiro a e b, defina uma função que some todos os números
# pares entre a e b.

def soma_pares_intervalo(a, b):
    '''
    Natural, Natural -> Natural
    Soma os número pares no intervalo [a, b].
    Exemplos
    >>> soma_pares_intervalo(3, 6) # 4 + 6
    10
    >>> soma_pares_intervalo(4, 9) # 4 + 6 + 8
    18
    '''
    soma = 0
    x = a
    while x <= b:
        if par(x):
            soma = soma + x
        x = x + 1
    return soma

def soma_pares_intervalo2(a, b):
    '''
    Natural, Natural -> Natural
    Soma os número pares no intervalo [a, b].
    Exemplos
    >>> soma_pares_intervalo2(3, 6) # 4 + 6
    10
    >>> soma_pares_intervalo2(4, 9) # 4 + 6 + 8
    18
    '''
    soma = 0
    for x in range(a, b + 1):
        if par(x):
            soma = soma + x
    return soma

def par(x):
    '''
    Natural -> Boolean
    Devolve True se x é par, False caso contrário.
    Exemplos
    >>> par(8)
    True
    >>> par(3)
    False
    '''
    return x % 2 == 0

# Exemplo 4
# Dado uma coleção de números, defina uma função que verifique se existem mais
# números pares ou mais números ímpares na coleção.

def mais_pares_ou_impares(xs):
    '''
    Lista Número -> String    
    Verifica se xs tem mais números pares os mais números ímpares.  Se tem mais
    pares, devolve 'pares', se tem mais ímpares, devolve 'ímpares', se tem o
    mesmo tanto de pares e ímpares devolve 'igual'.
    Exemplos
    >>> mais_pares_ou_impares([3, 4, 2, 6])
    'pares'
    >>> mais_pares_ou_impares([4, 6, 5, 2, 9, 1])
    'igual'
    >>> mais_pares_ou_impares([2, 3, 4, 1, 7])
    'ímpares'
    '''
    pares = 0
    impares = 0
    for i in range(0, len(xs)):
        if par(xs[i]):
            pares = pares + 1
        else:
            impares = impares + 1
    if pares > impares:
        return 'pares'
    else:
        if pares < impares:
            return 'ímpares'
        else:
            return 'igual'


def mais_pares_ou_impares2(xs):
    '''
    Lista Número -> String    
    Verifica se xs tem mais números pares os mais números ímpares.
    Se tem mais pares, devolve 'pares', se tem mais ímpares, devolve
    'ímpares', se tem o mesmo tanto de pares e ímpares devolve 'igual'.
    Exemplos
    >>> mais_pares_ou_impares2([3, 4, 2, 6])
    'pares'
    >>> mais_pares_ou_impares2([4, 6, 5, 2, 9, 1])
    'igual'
    >>> mais_pares_ou_impares2([2, 3, 4, 1, 7])
    'ímpares'
    '''
    pares = 0
    impares = 0
    for x in xs:
        if par(x):
            pares = pares + 1
        else:
            impares = impares + 1
    if pares > impares:
        return 'pares'
    elif pares < impares:
        return 'ímpares'
    else:
        return 'igual'


# Exemplo de definição de estrutura

class Ponto(Struct):
    '''
    Representa um ponto no plano cartesiano
        x : Número - é a coordenada x
        y : Número - é a coordenada y
    '''
    def __init__(self, x, y):
        self.init(x, y)


# Exemplo 6
# Defina uma função que calcule a distância cartesiana entre dois pontos.

def distancia(p1, p2):
    '''
    Ponto, Ponto -> Número
    Calcula a distância cartesiana entre p1 e p2.
    >>> distancia(Ponto(1, 4), Ponto(5, 1))
    5.0
    '''
    dx = p1.x - p2.x
    dy = p1.y - p2.y
    return (dx ** 2 + dy ** 2) ** 0.5


# Exemplo 7
# Defina uma função que encontre o ponto mais distante da origem de uma lista
# de pontos.

def ponto_mais_distante_origem(pontos):
    '''
    Lista Ponto -> Ponto
    Encontra o ponto da lista pontos mais distante da origem.
    >>> ponto_mais_distante_origem([Ponto(4, 3), Ponto(8, 3.5), Ponto(1, 2), Ponto(2,4)])
    Ponto(8, 3.5)
    '''
    origem = Ponto(0, 0)
    ponto_distante = pontos[0]
    maior_dist = distancia(origem, ponto_distante)
    for p in pontos:
        dist = distancia(origem, p)
        if dist > maior_dist:
            maior_dist = dist
            ponto_distante = p
    return ponto_distante

if __name__ == '__main__':
    executa_testes()
